{ lib, buildPythonPackage, python, fetchFromGitea, setuptools-scm, preserves
, websockets }:

buildPythonPackage rec {
  pname = "syndicate";
  version = "0.8.5";

  src = fetchFromGitea {
    domain = "git.syndicate-lang.org";
    owner = "syndicate-lang";
    repo = "${pname}-py";
    rev = "v${version}";
    sha256 = "sha256-OAvQxac06i8+R9zNWLjCtwOpVZ4t31q45ms6VuNyHGI=";
  };

  buildInputs = [ setuptools-scm ];
  propagatedBuildInputs = [ preserves websockets ];

  postInstall =
    "cp -rv syndicate/protocols $out/lib/${python.libPrefix}/site-packages/syndicate/";

  meta = src.meta // {
    homepage = "https://syndicate-lang.org";
    description = "An implementation of Syndicated Actors for Python";
    maintainers = with lib.maintainers; [ ehmry ];
  };
}
